Index: trunk/kernel/devices/dev_nic.c
===================================================================
--- trunk/kernel/devices/dev_nic.c	(revision 647)
+++ trunk/kernel/devices/dev_nic.c	(revision 657)
@@ -2,5 +2,5 @@
  * dev_nic.c - NIC (Network Controler) generic device API implementation.
  * 
- * Author  Alain Greiner    (2016,2017,2018,2019)
+ * Author  Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -24,15 +24,192 @@
 #include <hal_kernel_types.h>
 #include <hal_special.h>
+#include <hal_uspace.h>
+#include <remote_buf.h>
 #include <printk.h>
 #include <chdev.h>
 #include <thread.h>
+#include <socket.h>
 #include <hal_drivers.h>
 #include <dev_nic.h>
+#include <vfs.h>
+#include <shared_socket.h>
 
 /////////////////////////////////////////////////////////////////////////////////////////
-// Extern global variables
+//                 Extern global variables
 /////////////////////////////////////////////////////////////////////////////////////////
 
 extern chdev_directory_t  chdev_dir;         // allocated in kernel_init.c
+
+////////////////////////////////////////////////////////////////////////////////////////////
+// This static function is used by the dev_nic_rx_handle_tcp() & dev_nic_tx_handle_tcp()
+// functions to check acceptability of a given sequence number. It returns true when 
+// the <seq> argument is contained in a wrap-around window defined by the <min> and <max>
+// arguments. The window wrap-around when (min > max).
+////////////////////////////////////////////////////////////////////////////////////////////
+// @ seq   : [in] value to be checked.
+// @ min   : [in] first  base.
+// @ max   : [in] window size.
+////////////////////////////////////////////////////////////////////////////////////////////
+static inline bool_t is_in_window( uint32_t seq,
+                                   uint32_t min,
+                                   uint32_t max )
+{
+    if( max >= min )    // no wrap_around => only one window [min,max]
+    {
+        return( (seq >= min) && (seq <= max) ); 
+    }
+    else                // window wrap-around => two windows [min,0xFFFFFFFF] and [0,max]
+    {
+        return( (seq <= max) || (seq >= min) );
+    }
+}  
+
+////////////////////////////////////////////////////////////////////////////////////////////
+// this static function compute a channel index in range [0,nic_channelx[ from
+// a remote IP address and remote port.
+// TODO this function should be provided by the NIC driver.
+////////////////////////////////////////////////////////////////////////////////////////////
+// @ addr     : [in] IP address.
+// @ port     : [in] TCP/UDP port.
+////////////////////////////////////////////////////////////////////////////////////////////
+static inline uint32_t dev_nic_channel_index( uint32_t addr,
+                                              uint16_t port )
+{
+    // get number of NIC channels
+    uint32_t nic_channels = LOCAL_CLUSTER->nb_nic_channels;
+ 
+    // compute NIC channel index
+    return ( ((addr     ) & 0xFF) ^
+             ((addr > 8 ) & 0xFF) ^
+             ((addr > 16) & 0xFF) ^
+             ((addr > 24) & 0xFF) ^
+             ((port     ) & 0xFF) ^
+             ((port > 8 ) & 0xFF) ) % nic_channels;
+}
+
+////////////////////////////////////////////////////////////////////////////////////////
+// This static function computes the checksum for an IP packet header.
+// The "checksum" field itself is not taken into account for this computation.
+////////////////////////////////////////////////////////////////////////////////////////
+// @ buffer      : [in] pointer on IP packet header (20 bytes)
+// @ return the checksum value on 16 bits
+////////////////////////////////////////////////////////////////////////////////////////
+uint16_t dev_nic_ip_checksum( uint8_t  * buffer )
+{
+    uint32_t   i;           
+    uint32_t   cs;      // 32 bits accumulator
+    uint16_t * buf;     
+    
+    buf = (uint16_t *)buffer;
+
+    // compute checksum 
+    for( i = 0 , cs = 0 ; i < 10 ; i++ )
+    {
+        if( i != 5 )  cs += buf[i];
+    }
+
+    // one's complement
+    return ~cs;
+}
+
+////////////////////////////////////////////////////////////////////////////////////////
+// This static function computes the checksum for an UDP packet defined by 
+// the <buffer> and <size> arguments.
+////////////////////////////////////////////////////////////////////////////////////////
+// @ buffer      : [in] pointer on UDP packet base.
+// @ size        : [in] number of bytes in this packet (including header).
+// @ return the checksum value on 16 bits
+////////////////////////////////////////////////////////////////////////////////////////
+uint16_t dev_nic_udp_checksum( uint8_t  * buffer,
+                               uint32_t   size )
+{
+    uint32_t   i;           
+    uint32_t   carry;
+    uint32_t   cs;      // 32 bits accumulator
+    uint16_t * buf;     
+    uint32_t   max;     // number of uint16_t in packet
+    
+    // compute max & buf
+    buf = (uint16_t *)buffer;
+    max = size >> 1;
+
+    // extend buffer[] if required
+    if( size & 1 )
+    {
+        max++;
+        buffer[size] = 0;
+    }
+
+    // compute checksum for UDP packet
+    for( i = 0 , cs = 0 ; i < size ; i++ )  cs += buf[i];
+
+    // handle carry
+    carry = (cs >> 16);
+    if( carry ) 
+    {
+        cs += carry; 
+        carry = (cs >> 16);
+        if( carry ) cs += carry;
+    } 
+
+    // one's complement
+    return ~cs;
+}
+
+////////////////////////////////////////////////////////////////////////////////////////
+// This static function computes the checksum for a TCP segment defined by
+// the <buffer> and <size> arguments.
+// It includes the pseudo header defined by the <src_ip_addr>, <dst_ip_addr>,
+// <size> arguments, and by the TCP_PROTOCOL code.
+////////////////////////////////////////////////////////////////////////////////////////
+// @ buffer      : [in] pointer on TCP segment base.
+// @ size        : [in] number of bytes in this segment (including header).
+// @ src_ip_addr : [in] source IP address (pseudo header)
+// @ dst_ip_addr : [in] destination IP address (pseudo header)
+// @ return the checksum value on 16 bits
+////////////////////////////////////////////////////////////////////////////////////////
+uint16_t dev_nic_tcp_checksum( uint8_t  * buffer,
+                               uint32_t   size,
+                               uint32_t   src_ip_addr,
+                               uint32_t   dst_ip_addr )
+{
+    uint32_t   i;           
+    uint32_t   carry;
+    uint32_t   cs;      // 32 bits accumulator
+    uint16_t * buf;
+    uint32_t   max;     // number of uint16_t in segment
+
+    // compute max & buf
+    buf = (uint16_t *)buffer;
+    max = size >> 1;
+
+    // extend buffer[] if required
+    if( size & 1 )
+    {
+        max++;
+        buffer[size] = 0;
+    }
+
+    // compute checksum for TCP segment
+    for( i = 0 , cs = 0 ; i < size ; i++ )  cs += buf[i];
+
+    // complete checksum for pseudo-header
+    cs += src_ip_addr;
+    cs += dst_ip_addr;
+    cs += PROTOCOL_TCP;
+    cs += size;
+
+    // handle carry
+    carry = (cs >> 16);
+    if( carry ) 
+    {
+        cs += carry; 
+        carry = (cs >> 16);
+        if( carry ) cs += carry;
+    } 
+
+    // one's complement
+    return ~cs;
+}
 
 //////////////////////////////////
